+   [R 机器学习精要](docs/r-ml-essen/README.md)
	+   [零、前言](docs/r-ml-essen/0.md)
	+   [一、将数据转化为行动](docs/r-ml-essen/1.md)
	+   [二、R——开发机器学习算法的强大工具](docs/r-ml-essen/2.md)
	+   [三、一个简单的机器学习分析](docs/r-ml-essen/3.md)
	+   [四、第一步——数据探索和特征工程](docs/r-ml-essen/4.md)
	+   [五、第二步——应用机器学习技术](docs/r-ml-essen/5.md)
	+   [六、第三步——验证结果](docs/r-ml-essen/6.md)
	+   [七、机器学习技术回顾](docs/r-ml-essen/7.md)
	+   [八、适用于企业的机器学习示例](docs/r-ml-essen/8.md)
+   [R 机器学习示例](docs/r-ml-exam/README.md)
	+   [零、前言](docs/r-ml-exam/0.md)
	+   [一、R 和机器学习入门](docs/r-ml-exam/1.md)
	+   [二、让我们帮助机器学习](docs/r-ml-exam/2.md)
	+   [三、使用购物篮分析预测顾客购物趋势](docs/r-ml-exam/3.md)
	+   [四、构建产品推荐系统](docs/r-ml-exam/4.md)
	+   [五、信用风险检测和预测——描述性分析](docs/r-ml-exam/5.md)
	+   [六、信用风险检测和预测——预测分析](docs/r-ml-exam/6.md)
	+   [七、社交媒体分析——分析 Twitter 数据](docs/r-ml-exam/7.md)
	+   [八、Twitter 数据的情感分析](docs/r-ml-exam/8.md)
+   [R 机器学习项目](docs/r-ml-proj/README.md)
	+   [零、前言](docs/r-ml-proj/00.md)
	+   [一、探索机器学习的前景](docs/r-ml-proj/01.md)
	+   [二、使用集成模型预测员工流失](docs/r-ml-proj/02.md)
	+   [三、实现笑话推荐引擎](docs/r-ml-proj/03.md)
	+   [四、基于自然语言处理的亚马逊评论情感分析](docs/r-ml-proj/04.md)
	+   [五、批发数据的客户细分](docs/r-ml-proj/05.md)
	+   [六、使用深度神经网络的图像识别](docs/r-ml-proj/06.md)
	+   [七、使用自编码器的信用卡欺诈检测](docs/r-ml-proj/07.md)
	+   [八、基于循环神经网络的散文自动生成](docs/r-ml-proj/08.md)
	+   [九、通过强化学习赢得赌场老虎机](docs/r-ml-proj/09.md)
	+   [十、前方的路](docs/r-ml-proj/10.md)
+   [Scala 机器学习项目](docs/scala-ml-proj/README.md)
	+   [零、前言](docs/scala-ml-proj/00.md)
	+   [一、为索赔分析保险严重程度](docs/scala-ml-proj/01.md)
	+   [二、电信客户流失的分析和预测](docs/scala-ml-proj/02.md)
	+   [三、基于历史和实时数据的高频比特币价格预测](docs/scala-ml-proj/03.md)
	+   [四、人口规模聚类和种族预测](docs/scala-ml-proj/04.md)
	+   [五、主题建模——对大规模文本的更好理解](docs/scala-ml-proj/05.md)
	+   [六、开发基于模型的电影推荐引擎](docs/scala-ml-proj/06.md)
	+   [七、使用 Q 学习和 Scala Play 框架的期权交易](docs/scala-ml-proj/07.md)
	+   [八、基于深度神经网络的银行电话营销客户签约评估](docs/scala-ml-proj/08.md)
	+   [九、使用自编码器和异常检测的欺诈分析](docs/scala-ml-proj/09.md)
	+   [十、基于循环神经网络的人体行为识别](docs/scala-ml-proj/10.md)
	+   [十一、基于卷积神经网络的图像分类](docs/scala-ml-proj/11.md)
+   [R 与 SqlServer 2017 机器学习服务](docs/sqlsvr2017-ml-svc-r/README.md)
	+   [零、前言](docs/sqlsvr2017-ml-svc-r/00.md)
	+   [一、R 和 SQL Server 简介](docs/sqlsvr2017-ml-svc-r/01.md)
	+   [二、Microsoft 机器学习服务器和 SQL Server 概述](docs/sqlsvr2017-ml-svc-r/02.md)
	+   [三、为 SQL Server 2017 和 R 管理机器学习服务](docs/sqlsvr2017-ml-svc-r/03.md)
	+   [四、数据探索和数据可视化](docs/sqlsvr2017-ml-svc-r/04.md)
	+   [五、`RevoScaleR`包](docs/sqlsvr2017-ml-svc-r/05.md)
	+   [六、预测建模](docs/sqlsvr2017-ml-svc-r/06.md)
	+   [七、运维化 R 代码](docs/sqlsvr2017-ml-svc-r/07.md)
	+   [八、部署、管理和监控包含 R 代码的数据库解决方案](docs/sqlsvr2017-ml-svc-r/08.md)
	+   [九、面向数据库管理员的 R 机器学习服务](docs/sqlsvr2017-ml-svc-r/09.md)
	+   [十、R 和 SQL Server 2016/2017 功能扩展](docs/sqlsvr2017-ml-svc-r/10.md)
+   [Python 监督机器学习](docs/super-ml-py/README.md)
	+   [零、前言](docs/super-ml-py/0.md)
	+   [一、走向监督学习的第一步](docs/super-ml-py/1.md)
	+   [二、实现参数模型](docs/super-ml-py/2.md)
	+   [三、使用非参数模型](docs/super-ml-py/3.md)
	+   [四、监督机器学习的高级主题](docs/super-ml-py/4.md)
